#pragma once

typedef struct _ProcessList
{
	PVOID NextItem;
	PEPROCESS pEPROCESS;
	ULONG ProcessId;
} TProcessList, *PProcessList;

BOOLEAN IsAdded(PProcessList List, PEPROCESS pEPROCESS)
{
	PProcessList Item = List;

	while (Item)
	{
		if (pEPROCESS == Item->pEPROCESS)
			return TRUE;
		
		Item = Item->NextItem;
	}

	return FALSE;
}

void DelItem(PProcessList *List, PEPROCESS pEPROCESS)
{
	PProcessList Item = *List;
	PProcessList Prev = NULL;

	while (Item)
	{
		if (pEPROCESS == Item->pEPROCESS)
		{
			if (Prev) Prev->NextItem = Item->NextItem; 
			else 
				*List = Item->NextItem;
			
			ExFreePool(Item);
			return;
		}
		Prev = Item;
		Item = Item->NextItem;
	}
}

void FreePointers(PProcessList List)
{
	PProcessList Item = List;
	PVOID Mem;
	while (Item)
	{
		Mem = Item;	
		Item = Item->NextItem;
		ExFreePool(Mem);
	}
}

void AddItem(PProcessList *List, PEPROCESS pEPROCESS, ULONG ProcessId)
{
	PProcessList wNewItem;
	wNewItem = ExAllocatePool(NonPagedPool, sizeof(TProcessList));
	wNewItem->NextItem = *List;
	*List = wNewItem;
	wNewItem->pEPROCESS = pEPROCESS;
	wNewItem->ProcessId = ProcessId;
}