#pragma once

#pragma warning(disable:4214) // bit field types other than int
#pragma warning(disable:4201) // nameless struct/union

//
// TD_ASSERT
//
// This macro is identical to NT_ASSERT but works in fre builds as well.
//
// It is used for error checking in the driver in cases where
// we can't easily report the error to the user mode app, or the
// error is so severe that we should break in immediately to
// investigate.
//
// It's better than DbgBreakPoint because it provides additional info
// that can be dumped with .exr -1, and individual asserts can be disabled
// from kd using 'ahi' command.
//

#define TD_ASSERT(_exp) \
    ((!(_exp)) ? \
        (__annotation(L"Debug", L"AssertFail", L#_exp), \
         DbgRaiseAssertionFailure(), FALSE) : \
        TRUE)

#define TD_DRIVER_NAME             L"TestProject"
#define TD_DRIVER_NAME_WITH_EXT    L"TestProject.sys"

#define TD_NT_DEVICE_NAME          L"\\Device\\TestProject"
#define TD_DOS_DEVICES_LINK_NAME   L"\\DosDevices\\TestProject"
#define TD_WIN32_DEVICE_NAME       L"\\\\.\\TestProject"